#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

class VectorSorter {
private:
  unsigned int _index;

public:
  VectorSorter(unsigned int index) : _index(index) {}

  bool operator()(vector<int> const& v1, vector<int> const& v2) const {
    return v1[_index] < v2[_index];
  }
};

int main() {
  vector<vector<int>> data;

  for (int i = 0; i < 10; ++i) {
    vector<int> v;
    for(int j = 1; j <= 4; ++j) {
      int zahl = std::rand();
      v.push_back(zahl);
    }
    data.push_back(v);
  }

  cout << "Unsortiert: " << endl;
  for(int i = 0; i < 10; ++i) {
    cout << "v" << i << ": " << data[i][0] << ", " << data[i][1] <<
    ", " << data[i][2] << ", " << data[i][3] << endl;
  }
  cout << endl;

  // Fortsetzung folgt…
  // Fortsetzung:

  cout << "Nach erster Spalte sortiert: " << endl;
  std::sort(data.begin(), data.end(), VectorSorter(0));
  for (int i = 0; i < 10; ++i){
    cout << "v" << i << ": " << data[i][0] << ", " << data[i][1] <<
    ", " << data[i][2] << ", " << data[i][3] << endl;
  }
  cout << endl;

  cout << "Nach letzter Spalte sortiert: " << endl;
  std::sort(data.begin(), data.end(), VectorSorter(3));
  for(int i = 0; i < 10; ++i) {
    cout << "v" << i << ": " << data[i][0] << ", " << data[i][1] <<
    ", " << data[i][2] << ", " << data[i][3] << endl;
  }
}
