#include <iostream>
using namespace std;

class Point2D {
public:
  Point2D() : _x(0), _y(0) {}
  Point2D(double x, double y) : _x(x), _y(y) {}

  double getX() const {return _x;}
  double getY() const {return _y;}
  void setX(double x) {_x = x;}
  void setY(double y) {_y = y;}

private:
  double _x, _y;
};

std::ostream& operator<<(ostream& s, Point2D const& p){
  s << "Point2D[" << p.getX() << "," << p.getY() << "]";
  return s;
}

int main() {
  Point2D p1(23, 89);

  cout << p1 << endl;

  return 0;
}
